import java.awt.Graphics2D;


public class Function {
	Fraction sm = new Fraction(0,1); //sm*x^2
	Fraction mu = new Fraction(0,1); //mu*x
	Fraction yi = new Fraction(0,1); //+yi
	int de = 0;
	int ee = 0;
	int fe = 0;
	double pointY[] = new double[200];
	int length = 0;
	int type;
	public Function(int num,int a,int b,int c,int d,int e,int f,int g){
		if(num == 1){//Linear equations.
			if(a == 10)
				a = 1;
			if(b == 10)
				b = 1;
			if(c == 10)
				c = 0;
			mu = new Fraction(a,b);
			yi = new Fraction(c,1);
		}
		if(num == 2){//Quadratics.
			if(a == 10)
				a = 1;
			if(b == 10)
				b = 0;
			if(c == 10)
				c = 0;
			sm = new Fraction(a,1);
			mu = new Fraction(b,1);
			yi = new Fraction(c,1);
		}
		if(num == 3){
			if(a == 10)
				a = 1;
			if(b == 10)
				b = 0;
			if(c == 10)
				c = 0;
			sm = new Fraction(c,1);
			mu = new Fraction(a,1);
			yi = new Fraction(b,1);
		}
		if(num == 4){
			if(a == 10)
				a = 1;
			if(b == 10)
				b = 1;
			if(c == 10)
				c = 0;
			if(d == 10)
				d = 0;
			sm = new Fraction(c,1);
			mu = new Fraction(a,1);
			yi = new Fraction(b,1);
			de = d;
		}
		if(num == 5){
			if(a == 10)
				a = 0;
			if(b == 10)
				b = 0;
			if(c == 10)
				c = 0;
			if(d == 10)
				d = 0;
			if(e == 10)
				e = 0;
			if(f == 10)
				f = 0;
			sm = new Fraction(a,1);
			mu = new Fraction(b,1);
			yi = new Fraction(c,1);
			de = d;
			ee = e;
			fe = f;
		}
		type = num;
	}
	public double getY(double X){
		if(mu.getValue() == 1000000){//For "x=" equations.
			if(X < yi.getValue()){
				return 1000000;
			}else{
				return -1000000;
			}
		}
		if(type == 3){
			if(mu.getValue() == 0)
				return 0-(yi.getValue());
			return 0-(mu.getValue()/(X+sm.getValue())+yi.getValue());
		}
		if(type == 4){
			if(mu.getValue() == 0)
				return -de;
			if(sm.getValue()*X+yi.getValue() < 0)
				return 1000000;
			return 0-(mu.getValue()*Math.sqrt(yi.getValue()*X+sm.getValue())+de);
		}
		if(type == 5)
			return 0-((sm.getNumer()*X*X+mu.getNumer()*X+yi.getNumer())/(de*X*X+ee*X+fe));
		return 0-(sm.getValue()*X*X+mu.getValue()*X+yi.getValue());
	}
	public void extend(){
		pointY[length] = this.getY((((double)(length))/20)-5);
		length++;
	}
	public boolean draw(Graphics2D g, int b, int c, int d, int e,Player player){
		boolean retur = false;
		for(int i = 0;i < length - 1;i++){
			if(Math.abs(pointY[i + 1]) < 100 && Math.abs(pointY[i]) < 100 || type == 1){
				if(15>Math.sqrt(Math.pow((i*b/200 + d)-((int)(d + b * (player.X + 5) / 10 - player.size*3/4)),2)+Math.pow((e + (int)((pointY[i] + 5) * c / 10))-((int)(e + c * (player.Y + 5) / 10 - player.size*3/4)),2))){
					retur = true;
				}
				if(mu.getValue() > 1000){
					if(Math.abs((player.X - 1.5) - yi.getValue()) < 0.5 && 20 * (yi.getNumer() + 5) < length)
						return true;
				}
				g.drawLine(i*b/200 + d, e + (int)((pointY[i] + 5) * c / 10), (i+1)*b/200 + d, e + (int)((pointY[i + 1] + 5) * c / 10));
				g.drawLine(i*b/200 + d + 1, e + (int)((pointY[i] + 5) * c / 10), (i+1)*b/200 + d + 1, e + (int)((pointY[i + 1] + 5) * c / 10));
				g.drawLine(i*b/200 + d, e + (int)((pointY[i] + 5) * c / 10) + 1, (i+1)*b/200 + d, e + (int)((pointY[i + 1] + 5) * c / 10) + 1);
				g.drawLine(i*b/200 + d + 1, e + (int)((pointY[i] + 5) * c / 10) + 1, (i+1)*b/200 + d + 1, e + (int)((pointY[i + 1] + 5) * c / 10) + 1);
			}
		}
		return retur;
	}
	public String getText(){
		String result = "";
		if(type == 1){
			if(mu.getValue() == 1000000){//For "x=" equations.
				result = "x=";
				if(yi.getValue() < 0){
					result += "-";
					if(yi.getDenom() == -yi.getNumer() || Math.abs(yi.getDenom()) == 1){//Simplifying fractions like: "4/-1" or "-3/3".
						result += -(int)yi.getValue();
					}else{
						result += "`" + (int)Math.abs(yi.getNumer()) + "/`" + (int)Math.abs(yi.getDenom()) + "`";
					}
				}else if(yi.getValue() > 0){
					if(yi.getDenom() == yi.getNumer() || yi.getDenom() == 1){//Simplifying fractions like: "4/1" or "-3/-3".
						result += (int)yi.getValue();
					}else{
						result += "`" + (int)Math.abs(yi.getNumer()) + "/`" + (int)Math.abs(yi.getDenom()) + "`";
					}
				}else{
					result += "0";
				}
			}else{//"y=" equations.
				result = "y=";
				if(mu.getValue() < 0){//For stuff like "y=-_x__".
					result += "-";
					if(mu.getDenom() == -mu.getNumer() || Math.abs(mu.getDenom()) == 1){
						result += -(int)mu.getValue() + "x";
					}else{
						result += "`" + (int)Math.abs(mu.getNumer()) + "/`" + (int)Math.abs(mu.getDenom()) + "`x";
					}
				}
				if(mu.getValue() > 0){//For stuff like "y=_x__".
					if(mu.getDenom() == mu.getNumer() || mu.getDenom() == 1){
						result += (int)mu.getValue() + "x";
					}else{
						result += "`" + (int)Math.abs(mu.getNumer()) + "/`" + (int)Math.abs(mu.getDenom()) + "`x";
					}
				}
				if(mu.getValue() == 0){//For equations with no x value.
					if(yi.getValue() < 0){//For stuff like "y=-_"
						result += "-";
						if(yi.getDenom() == -yi.getNumer() || Math.abs(yi.getDenom()) == 1){
							result += -(int)yi.getValue();
						}else{
							result += "`" + (int)Math.abs(yi.getNumer()) + "/`" + (int)Math.abs(yi.getDenom()) + "`";
						}
					}else if(yi.getValue() > 0){//For stuff like "y=_"
						if(yi.getDenom() == yi.getNumer() || yi.getDenom() == 1){
							result += (int)yi.getValue();
						}else{
							result += "`" + (int)Math.abs(yi.getNumer()) + "/`" + (int)Math.abs(yi.getDenom()) + "`";
						}
					}else{//For "y=0"
						result += "0";
					}
				}else{//Writing y-intercept for equations with an x.
					if(yi.getValue() < 0){
						result += "-";
						if(yi.getDenom() == -yi.getNumer() || Math.abs(yi.getDenom()) == 1){
							result += -(int)yi.getValue();
						}else{
							result += "`" + (int)Math.abs(yi.getNumer()) + "/`" + (int)Math.abs(yi.getDenom()) + "`";
						}
					}
					if(yi.getValue() > 0){
						result += "+";
						if(yi.getDenom() == yi.getNumer() || yi.getDenom() == 1){
							result += (int)yi.getValue();
						}else{
							result += "`" + (int)Math.abs(yi.getNumer()) + "/`" + (int)Math.abs(yi.getDenom()) + "`";
						}
					}
				}
			}
		}
		if(type == 2){
			result = "y=";
			if(sm.getValue() < 0){
				result += "-" + -(int)sm.getValue() + "x^`2`";
			}else if(sm.getValue() > 0){
				result += (int)sm.getValue() + "x^`2`";
			}else{
				if(mu.getValue() < 0){
					result += "-" + -(int)mu.getValue() + "x";
				}else if(mu.getValue() > 0){
					result += (int)mu.getValue() + "x";
				}else{
					if(yi.getValue() < 0){
						result += "-" + -(int)yi.getValue();
					}else if(yi.getValue() > 0){
						result += (int)yi.getValue();
					}else{
						result += "0";
					}
				}
			}
			if(sm.getValue() != 0){
				if(mu.getValue() < 0){
					result += "-" + -(int)mu.getValue() + "x";
				}else if(mu.getValue() > 0){
					result += "+" + (int)mu.getValue() + "x";
				}else{
					if(yi.getValue() < 0){
						result += "-" + -(int)yi.getValue();
					}else if(yi.getValue() > 0){
						result += "+" + (int)yi.getValue();
					}
				}
				if(mu.getValue() != 0){
					if(yi.getValue() < 0){
						result += "-" + -(int)yi.getValue();
					}else if(yi.getValue() > 0){
						result += "+" + (int)yi.getValue();
					}
				}
			}
		}
		if(type == 3){
			if(mu.getValue() != 0){
				result = "y=`"+(int)mu.getValue()+"/`x";
				if(sm.getValue() == 0){
					result += "`";
				}else{
					if(sm.getValue() < 0){
						result += "-"+(-(int)sm.getValue())+"`";
					}else{
						result += "+"+(int)sm.getValue()+"`";
					}
				}
				if(yi.getValue() < 0){
					result += "-"+(-(int)yi.getValue());
				}else if(yi.getValue() > 0){
					result += "+"+(int)yi.getValue();
				}
			}else{
				result = "y="+(int)yi.getValue();
			}
		}
		if(type == 4){
			if(mu.getValue() != 0){
				result = "y="+(int)mu.getValue()+"?~";
				if(sm.getValue() == 0){
					result += "" + (int)yi.getValue() + "~";
				}else{
					if(sm.getValue() < 0){
						result += "-"+(-(int)sm.getValue()) + "*x";
					}else{
						result += ""+(int)sm.getValue() + "*x";
					}
					if(yi.getValue() < 0){
						result += "-"+(-(int)yi.getValue()) + "~";
					}else if(yi.getValue() > 0){
						result += "+"+(int)yi.getValue() + "~";
					}else{
						result += "~";
					}
				}
				if(de < 0){
					result += "-"+(-de);
				}else if(yi.getValue() > 0){
					result += "+"+de;
				}
			}else{
				result = "y="+de;
			}
		}
		if(type == 5){
			result = "y=`";
			if(sm.getValue() < 0){
				result += "-" + -(int)sm.getValue() + "x^`2`";
			}else if(sm.getValue() > 0){
				result += (int)sm.getValue() + "x^`2`";
			}else{
				if(mu.getValue() < 0){
					result += "-" + -(int)mu.getValue() + "x";
				}else if(mu.getValue() > 0){
					result += (int)mu.getValue() + "x";
				}else{
					if(yi.getValue() < 0){
						result += "-" + -(int)yi.getValue();
					}else if(yi.getValue() > 0){
						result += (int)yi.getValue();
					}else{
						result += "0";
					}
				}
			}
			if(sm.getValue() != 0){
				if(mu.getValue() < 0){
					result += "-" + -(int)mu.getValue() + "x";
				}else if(mu.getValue() > 0){
					result += "+" + (int)mu.getValue() + "x";
				}else{
					if(yi.getValue() < 0){
						result += "-" + -(int)yi.getValue();
					}else if(yi.getValue() > 0){
						result += "+" + (int)yi.getValue();
					}
				}
				if(mu.getValue() != 0){
					if(yi.getValue() < 0){
						result += "-" + -(int)yi.getValue();
					}else if(yi.getValue() > 0){
						result += "+" + (int)yi.getValue();
					}
				}
			}
			result += "/`";
			if(de < 0){
				result += "-" + -(int)de + "x^`2`";
			}else if(de > 0){
				result += (int)de + "x^`2`";
			}else{
				if(ee < 0){
					result += "-" + -(int)ee + "x";
				}else if(ee > 0){
					result += (int)ee + "x";
				}else{
					if(fe < 0){
						result += "-" + -(int)fe;
					}else if(fe > 0){
						result += (int)fe;
					}else{
						result += "0";
					}
				}
			}
			if(de != 0){
				if(ee < 0){
					result += "-" + -(int)ee + "x";
				}else if(ee > 0){
					result += "+" + (int)ee + "x";
				}else{
					if(fe < 0){
						result += "-" + -(int)fe;
					}else if(fe > 0){
						result += "+" + (int)fe;
					}
				}
				if(ee != 0){
					if(fe < 0){
						result += "-" + -(int)fe;
					}else if(fe > 0){
						result += "+" + (int)fe;
					}
				}
			}
			result += "`";
		}
		return result;
	}
}
