import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import java.awt.geom.AffineTransform;
public class Button
{
    private int x;
    private int y;
    private int width;
    private int height;
    private String imageName;
    private boolean mousedOver;
    private double inflation = 1.1;
    public Button(int a,int b,int c,int d,String e)
    {
        x = a;
        y = b;
        width = c;
        height = d;
        imageName = e;
        mousedOver = false;
    }
    
    public boolean clickTest(int a,int b, boolean c){
        if(a >= x && b >= y && a <= x + width && b <= y + height){
            mousedOver = true;
            if(c){
                return true;
            }
        }else{
            mousedOver = false;
        }
        return false;
    }

    public void draw(Graphics2D g)
    {
        try
        {
            Image headP = ImageIO.read(new File(imageName));
            AffineTransform op = new AffineTransform();
            AffineTransform nl = new AffineTransform();
            if(mousedOver){
                op.translate(x - (width*inflation-width) / 2,y - (height*inflation-height) / 2);
                op.scale(inflation,inflation);
            }else{
                op.scale(1,1);
                op.translate(x,y);
            }
            g.setTransform(op);
            g.drawImage(headP,0,0,null);
            g.setTransform(nl);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }
}
