import java.awt.Graphics2D;

import javax.imageio.ImageIO;
import java.io.IOException;
import java.io.File;
import java.awt.Image;

public class Player {
    double X;
    double Y;
    double XV;
    double YV;
    int size;
    private int screenSizeX;
    private int screenSizeY;
    private int screenOffsetX;
    private int screenOffsetY;
    public Player(int a, int b, int c, int d, int e){
        X = 0;
        Y = 0;
        XV = 0;
        YV = 0;
        size = a;
        screenSizeX = b;
        screenSizeY = c;
        screenOffsetX = d;
        screenOffsetY = e;
    }

    public void draw(Graphics2D g, int gameState){
        if(gameState == 1){
            g.drawOval((int)(screenOffsetX + screenSizeX * (X + 5) / 10 - size), (int)(screenOffsetY + screenSizeY * (Y + 5) / 10 - size), size / 2, size / 2);
        }else{
            try{
                Image blood = ImageIO.read(new File("Images/KBM_Blood.png"));
                g.drawImage(blood, (int)(screenOffsetX + screenSizeX * (X + 5) / 10 - size) - 20, (int)(screenOffsetY + screenSizeY * (Y + 5) / 10 - size) - 20, null);
            }catch(Exception e){
                e.printStackTrace();
            }
        }
    }

    public void move(double xm, double ym){
        XV += xm;
        YV += ym;
        X += XV;
        Y += YV;
        XV *= 0.85;
        YV *= 0.85;
        if(X > 6){
        	X = 6;
        	XV = -XV;
        }
        if(X < -3){
        	X = -3;
        	XV = -XV;
        }
        if(Y > 6){
        	Y = 6;
        	YV = -YV;
        }
        if(Y < -3){
        	Y = -3;
        	YV = -YV;
        }
    }
}
