
import java.util.*;

import javax.swing.*;

import java.util.*;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.*;
import java.io.IOException;

import javax.imageio.ImageIO;

import java.awt.event.*;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.File;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
public class driver extends JFrame implements Runnable, MouseListener, MouseMotionListener, KeyListener//Other implementables
{
    Container con = getContentPane();
    Thread t = new Thread(this);
    // All variables and objects declared here.
    Image title;
    Image infoScreen;
    int playerSize = 60;
    int screenSizeX = 300;
    int screenSizeY = 300;
    int screenOffsetX = 50;
    int screenOffsetY = 150;
    Player player = new Player(playerSize, screenSizeX, screenSizeY, screenOffsetX, screenOffsetY);
    ArrayList<Function> F = new ArrayList<Function>();
    int functionsActive = 0;
    int functionsLimit = 5;
    Function draw;
    int functionProgress = 0;
    int level = 0;
    int score = 0;
    int score2 = 0;
    int highScore = 0;
    int levelProgress = 0;
    int levelRequirements[] = new int[18];
    String levelFunctions[] = new String[18];
    ArrayList<Integer> availableFunctions = new ArrayList<Integer>();
    Boolean[][] availableFunctionCoefficients = new Boolean[17][7];//17 types of functions, 7 variables.
    boolean wdown = false;
    boolean adown = false;
    boolean sdown = false;
    boolean ddown = false;
    double mouseX = 0;
    double mouseY = 0;
    boolean mouseDown = false;
    double xm = 0;
    double ym = 0;
    Button Start = new Button(100,180,200,70,"Images/KBM_Start.png");
    Button Info = new Button(100,260,200,70,"Images/KBM_Info.png");
    Button Back = new Button(100,340,200,70,"Images/KBM_Back.png");
    Button Exit = new Button(100,340,200,70,"Images/KBM_Exit.png");
    int gameState = 0;
    Text display = new Text("y=x");
    public driver()
    {
        addKeyListener(this);
        addMouseListener(this);
        addMouseMotionListener(this);
        con.setLayout(new FlowLayout());
        /*
        All variables initialized here
        All objects instantiated here
        All Listeners added here
         */
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        t.start();
    }

    public void keyPressed(KeyEvent me){
        if(me.getKeyChar()=='w' || me.getKeyCode() == KeyEvent.VK_UP){
            wdown = true;
        }
        if(me.getKeyChar()=='s' || me.getKeyCode() == KeyEvent.VK_DOWN){
            sdown = true;
        }
        if(me.getKeyChar()=='a' || me.getKeyCode() == KeyEvent.VK_LEFT){
            adown = true;
        }
        if(me.getKeyChar()=='d' || me.getKeyCode() == KeyEvent.VK_RIGHT){
            ddown = true;
        }
    }

    public void keyReleased(KeyEvent me){
        if(me.getKeyChar()=='w' || me.getKeyCode() == KeyEvent.VK_UP){
            wdown = false;
        }
        if(me.getKeyChar()=='s' || me.getKeyCode() == KeyEvent.VK_DOWN){
            sdown = false;
        }
        if(me.getKeyChar()=='a' || me.getKeyCode() == KeyEvent.VK_LEFT){
            adown = false;
        }
        if(me.getKeyChar()=='d' || me.getKeyCode() == KeyEvent.VK_RIGHT){
            ddown = false;
        }
    }

    public void keyTyped(KeyEvent me){
    }

    public void mousePressed(MouseEvent e) {
        mouseDown = true;
    }

    public void mouseReleased(MouseEvent e) {
        mouseDown = false;
    }

    public void mouseDragged(MouseEvent e) {
        mouseX = e.getX();
        mouseY = e.getY();
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseMoved(MouseEvent e) {
        mouseX = e.getX();
        mouseY = e.getY();
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
    }

    public void run()
    {
        try{
            try{
                FileReader fw = new FileReader("Settings/LevelRequirements.txt");
                BufferedReader pw = new BufferedReader(fw);
                for(int k = 0;k < 18;k++) //Gets the amount of points needed for each level.
                    levelRequirements[k] = Integer.parseInt(pw.readLine());
                pw.close();
                fw = new FileReader("Settings/LevelFunctions.txt");
                pw = new BufferedReader(fw);
                for(int k = 0;k < 18;k++) //Gets the functions that can appear on each level.
                    levelFunctions[k] = pw.readLine();
                pw.close();
                fw = new FileReader("Settings/HighScore.dontedit");
                pw = new BufferedReader(fw);
                highScore = Integer.parseInt(pw.readLine());
                pw.close();
            }catch(Exception e){
                e.printStackTrace();
            }
            int lastFunctionStored = 0;
            availableFunctions = new ArrayList<Integer>();
            for(int y = 0;y < 17;y++){
                for(int u = 0;u < 7;u++){
                    availableFunctionCoefficients[y][u] = false;
                }
            }
            for(int y = 0;y < levelFunctions[level].length();y++){
                if(levelFunctions[level].charAt(y) == '1'){
                    availableFunctions.add(1);
                    lastFunctionStored = 0;
                }
                if(levelFunctions[level].charAt(y) == '2'){
                    availableFunctions.add(2);
                    lastFunctionStored = 1;
                }
                if(levelFunctions[level].charAt(y) == '3'){
                    availableFunctions.add(3);
                    lastFunctionStored = 2;
                }
                if(levelFunctions[level].charAt(y) == '4'){
                    availableFunctions.add(4);
                    lastFunctionStored = 3;
                }
                if(levelFunctions[level].charAt(y) == '5'){
                    availableFunctions.add(5);
                    lastFunctionStored = 4;
                }
                if(levelFunctions[level].charAt(y) == 'a')
                    availableFunctionCoefficients[lastFunctionStored][0] = true;
                if(levelFunctions[level].charAt(y) == 'b')
                    availableFunctionCoefficients[lastFunctionStored][1] = true;
                if(levelFunctions[level].charAt(y) == 'c')
                    availableFunctionCoefficients[lastFunctionStored][2] = true;
                if(levelFunctions[level].charAt(y) == 'd')
                    availableFunctionCoefficients[lastFunctionStored][3] = true;
                if(levelFunctions[level].charAt(y) == 'e')
                    availableFunctionCoefficients[lastFunctionStored][4] = true;
                if(levelFunctions[level].charAt(y) == 'f')
                    availableFunctionCoefficients[lastFunctionStored][5] = true;
                if(levelFunctions[level].charAt(y) == 'g')
                    availableFunctionCoefficients[lastFunctionStored][6] = true;
            }

            while(gameState != 6)
            {
                if(gameState == 0){
                    t.sleep(10);
                    if(Start.clickTest((int)mouseX, (int)mouseY, mouseDown)){
                        gameState = 1;
                        mouseDown = false;
                    }
                    if(Info.clickTest((int)mouseX, (int)mouseY, mouseDown)){
                        gameState = 3;
                        mouseDown = false;
                    }
                    if(Exit.clickTest((int)mouseX, (int)mouseY, mouseDown)){
                        gameState = 6;
                        mouseDown = false;
                    }
                    repaint();
                }else if(gameState == 1){
                    t.sleep(10);
                    score2++;
                    if(levelProgress == levelRequirements[level]){//Progresses to next level when requirements are met.
                        level++;
                        levelProgress = 0;
                        lastFunctionStored = 0;
                        availableFunctions = new ArrayList<Integer>();
                        for(int y = 0;y < 17;y++){
                            for(int u = 0;u < 7;u++){
                                availableFunctionCoefficients[y][u] = false;
                            }
                        }
                        for(int y = 0;y < levelFunctions[level].length();y++){
                            if(levelFunctions[level].charAt(y) == '1'){
                                availableFunctions.add(1);
                                lastFunctionStored = 0;
                            }
                            if(levelFunctions[level].charAt(y) == '2'){
                                availableFunctions.add(2);
                                lastFunctionStored = 1;
                            }
                            if(levelFunctions[level].charAt(y) == '3'){
                                availableFunctions.add(3);
                                lastFunctionStored = 2;
                            }
                            if(levelFunctions[level].charAt(y) == '4'){
                                availableFunctions.add(4);
                                lastFunctionStored = 3;
                            }
                            if(levelFunctions[level].charAt(y) == '5'){
                                availableFunctions.add(5);
                                lastFunctionStored = 4;
                            }
                            if(levelFunctions[level].charAt(y) == 'a')
                                availableFunctionCoefficients[lastFunctionStored][0] = true;
                            if(levelFunctions[level].charAt(y) == 'b')
                                availableFunctionCoefficients[lastFunctionStored][1] = true;
                            if(levelFunctions[level].charAt(y) == 'c')
                                availableFunctionCoefficients[lastFunctionStored][2] = true;
                            if(levelFunctions[level].charAt(y) == 'd')
                                availableFunctionCoefficients[lastFunctionStored][3] = true;
                            if(levelFunctions[level].charAt(y) == 'e')
                                availableFunctionCoefficients[lastFunctionStored][4] = true;
                            if(levelFunctions[level].charAt(y) == 'f')
                                availableFunctionCoefficients[lastFunctionStored][5] = true;
                            if(levelFunctions[level].charAt(y) == 'g')
                                availableFunctionCoefficients[lastFunctionStored][6] = true;
                        }
                    }
                    if(functionProgress == 0){
                        int functionChosen = (int)(Math.random() * availableFunctions.size());
                        int coefficients[] = new int[7];
                        for(int u = 0;u < 7;u++){
                            coefficients[u] = 10;
                            if(availableFunctionCoefficients[functionChosen][u])
                                coefficients[u] = (int)(Math.random() * 10 - 5);
                        }
                        draw = new Function(functionChosen + 1,coefficients[0],coefficients[1],coefficients[2],coefficients[3],coefficients[4],coefficients[5],coefficients[6]);
                        display = new Text(draw.getText());
                        score++;
                        levelProgress++;
                    }
                    if(functionProgress == 200){
                        if(functionsActive == functionsLimit){
                            for(int t = 0;t < functionsLimit - 1;t++){
                                F.set(t,F.get(t + 1));
                            }
                            F.set(functionsLimit - 1,draw);
                        }else{
                            F.add(draw);
                            functionsActive++;
                        }
                        functionProgress = 0;
                    }else{
                        functionProgress++;
                        draw.extend();
                    }
                    if(wdown){
                        ym = -0.01;
                    }else if(sdown){
                        ym = 0.01;
                    }else{
                        ym = 0;
                    }
                    if(adown){
                        xm = -0.01;
                    }else if(ddown){
                        xm = 0.01;
                    }else{
                        xm = 0;
                    }
                    player.move(xm, ym);
                }else{
                    if(Back.clickTest((int)mouseX, (int)mouseY, mouseDown)){
                        gameState = 0;
                        playerSize = 60;
                        screenSizeX = 300;
                        screenSizeY = 300;
                        screenOffsetX = 50;
                        screenOffsetY = 150;
                        player = new Player(playerSize, screenSizeX, screenSizeY, screenOffsetX, screenOffsetY);
                        F = new ArrayList<Function>();
                        functionsActive = 0;
                        functionsLimit = 5;
                        functionProgress = 0;
                        level = 0;
                        score = 0;
                        score2 = 0;
                        highScore = 0;
                        levelProgress = 0;
                        levelRequirements = new int[18];
                        levelFunctions = new String[18];
                        availableFunctions = new ArrayList<Integer>();
                        availableFunctionCoefficients = new Boolean[17][7];//17 types of functions, 7 variables.
                        wdown = false;
                        adown = false;
                        sdown = false;
                        ddown = false;
                        mouseX = 0;
                        mouseY = 0;
                        mouseDown = false;
                        xm = 0;
                        ym = 0;
                        display = new Text("y=x");
                        try{
                            FileReader fw = new FileReader("Settings/LevelRequirements.txt");
                            BufferedReader pw = new BufferedReader(fw);
                            for(int k = 0;k < 18;k++) //Gets the amount of points needed for each level.
                                levelRequirements[k] = Integer.parseInt(pw.readLine());
                            pw.close();
                            fw = new FileReader("Settings/LevelFunctions.txt");
                            pw = new BufferedReader(fw);
                            for(int k = 0;k < 18;k++) //Gets the functions that can appear on each level.
                                levelFunctions[k] = pw.readLine();
                            pw.close();
                            fw = new FileReader("Settings/HighScore.dontedit");
                            pw = new BufferedReader(fw);
                            highScore = Integer.parseInt(pw.readLine());
                            pw.close();
                        }catch(Exception e){
                            e.printStackTrace();
                        }
                        lastFunctionStored = 0;
                        availableFunctions = new ArrayList<Integer>();
                        for(int y = 0;y < 17;y++){
                            for(int u = 0;u < 7;u++){
                                availableFunctionCoefficients[y][u] = false;
                            }
                        }
                        for(int y = 0;y < levelFunctions[level].length();y++){
                            if(levelFunctions[level].charAt(y) == '1'){
                                availableFunctions.add(1);
                                lastFunctionStored = 0;
                            }
                            if(levelFunctions[level].charAt(y) == '2'){
                                availableFunctions.add(2);
                                lastFunctionStored = 1;
                            }
                            if(levelFunctions[level].charAt(y) == '3'){
                                availableFunctions.add(3);
                                lastFunctionStored = 2;
                            }
                            if(levelFunctions[level].charAt(y) == '4'){
                                availableFunctions.add(4);
                                lastFunctionStored = 3;
                            }
                            if(levelFunctions[level].charAt(y) == 'a')
                                availableFunctionCoefficients[lastFunctionStored][0] = true;
                            if(levelFunctions[level].charAt(y) == 'b')
                                availableFunctionCoefficients[lastFunctionStored][1] = true;
                            if(levelFunctions[level].charAt(y) == 'c')
                                availableFunctionCoefficients[lastFunctionStored][2] = true;
                            if(levelFunctions[level].charAt(y) == 'd')
                                availableFunctionCoefficients[lastFunctionStored][3] = true;
                            if(levelFunctions[level].charAt(y) == 'e')
                                availableFunctionCoefficients[lastFunctionStored][4] = true;
                            if(levelFunctions[level].charAt(y) == 'f')
                                availableFunctionCoefficients[lastFunctionStored][5] = true;
                            if(levelFunctions[level].charAt(y) == 'g')
                                availableFunctionCoefficients[lastFunctionStored][6] = true;
                        }
                    }
                }
                repaint();
            }
            System.exit(0);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public void paint(Graphics gr)
    {
        Image i=createImage(getSize().width, getSize().height);
        Graphics2D g = (Graphics2D)i.getGraphics();
        try
        {
            title = ImageIO.read(new File("Images/KBM_Title.png"));
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        try
        {
            infoScreen = ImageIO.read(new File("Images/KBM_InfoScreen.png"));
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        g.setColor(new Color(216, 236, 255));
        g.fillRect(0, 0, 600, 600);
        if(gameState == 0){
            AffineTransform op = new AffineTransform();
            AffineTransform nl = new AffineTransform();
            op.scale(0.6,0.6);
            g.setTransform(op);
            g.drawImage(title, 30, 80, this);
            g.setTransform(nl);
            Start.draw(g);
            Info.draw(g);
            Exit.draw(g);
        }else if(gameState == 3){
            AffineTransform op = new AffineTransform();
            AffineTransform nl = new AffineTransform();
            op.scale(0.6,0.6);
            g.setTransform(op);
            g.drawImage(infoScreen, 30, 80, this);
            g.setTransform(nl);
            Back.draw(g);
        }else if(gameState == 1 || gameState == 2){
            g.setColor(new Color(216, 236, 255));
            g.fillRect(50, 150, 300, 300);
            g.fillRect(65, 50, 270, 80);
            g.setColor(new Color(128, 192, 255));
            g.drawLine(200,150,200,450);
            g.drawLine(201,150,201,450);
            g.drawLine(0,300,450,300);
            g.drawLine(0,301,450,301);
            for(int j = 0; j < 9; j++){
                g.drawLine(80 + 30 * j,150,80 + 30 * j,450);
                g.drawLine(0,180 + 30 * j,450,180 + 30 * j);
            }
            g.setColor(new Color(96, 128, 192));
            //  *Drawing Functions
            if(draw.draw(g, screenSizeX, screenSizeY, screenOffsetX, screenOffsetY, player)){
                gameState = 2;
            }
            for(int j = 0;j < functionsActive;j++){
                if(F.get(j).draw(g, screenSizeX, screenSizeY, screenOffsetX, screenOffsetY, player)){
                    gameState = 2;
                }
            }
            //  *Drawing Player
            player.draw(g,gameState);
            //  *Drawing Background
            g.setColor(new Color(192, 216, 255));
            g.fillRect(0, 0, 500, 150);
            g.fillRect(0, 0, 50, 500);
            g.fillRect(350, 0, 50, 500);
            g.fillRect(0, 450, 500, 50);
            g.setColor(new Color(128, 192, 255));
            g.drawRect(50, 150, 300, 300);
            g.drawRect(51, 151, 298, 298);
            g.setColor(new Color(216, 236, 255));
            g.fillRect(40, 35, 320, 100);
            g.setColor(new Color(128, 192, 255));
            g.drawRect(40, 35, 320, 100);
            g.drawRect(41, 36, 318, 98);
            display.draw(g);
            if(gameState == 2){
                Back.draw(g);
                if(score2 > highScore){
                    try{
                        FileWriter outFile = new FileWriter("Settings/HighScore.dontedit");
                        BufferedWriter bw = new BufferedWriter(outFile);
                        bw.write(""+score2);
                        bw.close();
                    }catch(Exception a){
                        System.out.println("ERROR: File \"freemidis_002.midi.exe\" does not exist.");
                    }
                    highScore = score2;
                }
                BufferedImage CharSheet = null;
                Image death = null;
                try {
                    CharSheet = ImageIO.read(new File("Images/KBM_Score.png"));
                    death = ImageIO.read(new File("Images/KBM_Death.png"));
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
                g.drawImage(death,50,100,null);
                for(int a = 0; a < Math.log10(score2); a++){
                    int digit = (int)(((score2 % Math.pow(10,a+1)) - score2 % Math.pow(10,a)) / Math.pow(10,a));
                    BufferedImage CroppedCharSheet = CharSheet.getSubimage(16*digit + 3,0,14,20);
                    g.drawImage(CroppedCharSheet,220-16*(a-(int)Math.log10(score2)),200,null);
                }
                for(int a = 0; a < Math.log10(highScore); a++){
                    int digit = (int)(((highScore % Math.pow(10,a+1)) - highScore % Math.pow(10,a)) / Math.pow(10,a));
                    BufferedImage CroppedCharSheet = CharSheet.getSubimage(16*digit + 3,0,14,20);
                    g.drawImage(CroppedCharSheet,220-16*(a-(int)Math.log10(highScore)),231,null);
                }
            }
        }
        g.dispose();
        gr.drawImage(i, 0, 0, this);
    }

    public static void main(String[] args)
    {
        driver frame = new driver();
        frame.setSize(400, 500);
        frame.setVisible(true);
    }

    public void update(Graphics g)
    {
        paint(g);
    } 

}